#ifndef lint
static char rcsid[] = "$Header: /net/hopkins/var/home/tristan/mpeg/dec/lib/RCS/clip.c,v 1.4 1997/10/21 09:54:14 tristan Exp $";
static char copyright[] = "Copyright (c) 1997, MpegTV LLC";
#endif


/*
 * Disclaimer of Warranty
 *
 * These software programs are available to the user without any license fee or
 * royalty on an "as is" basis.  Copyright-holder disclaims
 * any and all warranties, whether express, implied, or statuary, including any
 * implied warranties or merchantability or of fitness for a particular
 * purpose.  In no event shall the copyright-holder be liable for any
 * incidental, punitive, or consequential damages of any kind whatsoever
 * arising from the use of these programs.
 *
 * This disclaimer of warranty extends to the user of these programs and user's
 * customers, employees, agents, transferees, successors, and assigns.
 *
 */

#include "mtvp/misc.h"
#include "clip.h"

/*--------------------------------------------------------------------------+
| Macros																	|
+--------------------------------------------------------------------------*/

#if 0 /* Tristan Savatier - Tue Oct 21 01:18:46 PDT 1997 */
//#define NUM_CLIP_ENTRIES (2048+2*MAX_NEG_CLIP)
#endif /* 0 - Tristan Savatier - Tue Oct 21 01:18:47 PDT 1997 */
#define NUM_CLIP_ENTRIES (2*MAX_NEG_CLIP)

#ifdef CLIP_0_255_CACHE
u_char Clip_table_0_255[NUM_CLIP_ENTRIES];
#endif

#ifdef CLIP_M128_127_CACHE
char Clip_table_M128_127[NUM_CLIP_ENTRIES];
#endif


/*--------------------------------------------------------------------------+
| clip_init																	|
+--------------------------------------------------------------------------*/
void
clip_init ()
{
	int     i;

	/*
	 * Initialize clamping cache tables
	 */

	for (i = (-MAX_NEG_CLIP); i < NUM_CLIP_ENTRIES - MAX_NEG_CLIP; i++) {
#ifdef CLIP_0_255_CACHE
		if (i <= 0) {
#if 0							/* Tristan Savatier - Fri Apr 26 03:25:23 PDT 1996 */
//      Clip_table_0_255[i + MAX_NEG_CLIP] = 0;
#endif /* 0 */
		} else if (i >= 255) {
			Clip_table_0_255[i + MAX_NEG_CLIP] = 255;
		} else {
			Clip_table_0_255[i + MAX_NEG_CLIP] = i;
		}
#endif

#ifdef CLIP_M128_127_CACHE
		if (i <= -128) {
			Clip_table_M128_127[i + MAX_NEG_CLIP] = -128;
		} else if (i >= 127) {
			Clip_table_M128_127[i + MAX_NEG_CLIP] = 127;
		} else {
			Clip_table_M128_127[i + MAX_NEG_CLIP] = i;
		}
#endif
	}
}

